cv.kmax <-
function(X){

n<-dim(X)[1];p<-dim(X)[2]

S<-t(X)%*%X/n

svd.S<-svd(S)

## Predictive risk selection procedure : Selection of kmax
## k-fold cross validation 

kk<-5 ## 5-fold CV


h <- n/kk  
cv.set <- matrix(0,kk,h)
    
    for(i in 1:kk){
        cv.set[i,] <- kk*c(1:h)-(kk-i)
    }   


mm <- 20
nu <- seq(1.1, 100,,mm)
    
    PR<- rep(0,mm) ## predictive risk 
    
       
    for(i in 1:mm){       
    
    X.k <- NULL
    
    loss.k<-rep(0,kk)
        
    for(k in 1:kk) {
    
    X.ok <- X[-cv.set[k,],]   
    
    n.ok<-dim(X.ok)[1]
    p.ok<-dim(X.ok)[2]
    
    S.ok<- t(X.ok)%*%X.ok/n.ok
       
    svd.Sok<-svd(S.ok)
    
    V.ok <- svd.Sok$v
    
    cond.S.ok<-max(svd.Sok$d)/min(svd.Sok$d)
    
    kmax_temp<-nu[i]
    
    if (nu[i]> cond.S.ok){kmax_temp<- cond.S.ok-0.01}
    
    mu.k<-Shrink.cond(X.ok,kmax_temp)
    
    
    X.k <- X[cv.set[k,],]
    n.k<-dim(X.k)[1]
    
    loss.k[k]<- -(1/2)* sum(diag(X.k%*%V.ok%*%diag(mu.k)%*%t(X.k%*%V.ok))) + n.k/2*sum(log(mu.k))
    
                       
    }
    
    PR[i]<- -1/n*sum(loss.k)
    }
    
ind.cv <- (1:mm)[which.min(PR)]

kmax <- nu[ind.cv]

return(list(kmax=kmax, PR=PR))
}

