sspca <-
function(X, penalty='HL',super=TRUE, nc=1, tuning='CV'){
    
    svd.X<-svd(X)
    
    X.new<-X
    n<-dim(X)[1];p<-dim(X)[2]
    
    if (super==TRUE) {    
        ## kmax selection from k-fold CV
        
        if (n<p) { cvkmax<-cv.kmax(t(X)); kmax<-cvkmax$kmax }
            else { cvkmax<-cv.kmax(X); kmax<-cvkmax$kmax }
     
        
        if (n<p) {mu_final<-Shrink.cond(t(X),kmax)} ## shrinkage eigenvalue
            else {mu_final<-Shrink.cond(X,kmax)}
            
        X2<- svd.X$u %*% diag(sqrt(max(n,p)/mu_final)) %*% t(svd.X$v) ## Shrinkage estimator of X
        X.new<-X2
    }
    
    ## Number of components
    if (is.null(nc)) {nc<-1}
    
    
    V<-matrix(0,n,nc)    #score
    A<-matrix(0,p,nc)    #loading
    L<-rep(0,nc)         #lambda
    
    ## Implementation of sspca
    for (cnt in 1:nc){
    
        if (tuning[1]=="CV") {lambda<-cv.lamx(X.new,penalty=penalty)$lamx}
        if (is.numeric(tuning)) {lambda<-tuning[cnt]}
        
        sspca.rst<-NIPALS.PCA(X.new,lambda, penalty=penalty)
        V[,cnt]<-sspca.rst$v1
        A[,cnt]<-sspca.rst$a1
        L[cnt]<-lambda
        
        X.new<-X.new-V[,cnt]%*%t(A[,cnt])
       
        #print(c("Component Num =",cnt))
        cat("Computng Component number ",cnt,"\n")
    }
    
return(list(PC=V,  Loading=A,  lambda=L))
}

